"""
    HW Mux Reservation System

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 2.1.4
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from hwmux_client.api_client import ApiClient, Endpoint as _Endpoint
from hwmux_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from hwmux_client.model.paginated_reservation_session_serializer_read_only_list import PaginatedReservationSessionSerializerReadOnlyList
from hwmux_client.model.reservation_request import ReservationRequest
from hwmux_client.model.reservation_session_serializer_read_only import ReservationSessionSerializerReadOnly


class ReservationsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.reservations_active_list_endpoint = _Endpoint(
            settings={
                'response_type': (PaginatedReservationSessionSerializerReadOnlyList,),
                'auth': [
                    'cookieAuth',
                    'tokenAuth'
                ],
                'endpoint_path': '/api/reservations/active/',
                'operation_id': 'reservations_active_list',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'a_device_groups',
                    'a_devices',
                    'details',
                    'id',
                    'owner',
                    'page',
                    'r_device_group_labels',
                    'r_device_groups',
                    'r_devices',
                    'search',
                    't_completed',
                    't_completed__after',
                    't_completed__before',
                    't_lease_expires',
                    't_lease_expires__after',
                    't_lease_expires__before',
                    't_requested',
                    't_requested__after',
                    't_requested__before',
                    't_satisfied',
                    't_satisfied__after',
                    't_satisfied__before',
                    'use_watchdog',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'a_device_groups':
                        ([int],),
                    'a_devices':
                        ([int],),
                    'details':
                        (str,),
                    'id':
                        (str,),
                    'owner':
                        (int,),
                    'page':
                        (int,),
                    'r_device_group_labels':
                        ([int],),
                    'r_device_groups':
                        ([int],),
                    'r_devices':
                        ([int],),
                    'search':
                        (str,),
                    't_completed':
                        (datetime,),
                    't_completed__after':
                        (datetime,),
                    't_completed__before':
                        (datetime,),
                    't_lease_expires':
                        (datetime,),
                    't_lease_expires__after':
                        (datetime,),
                    't_lease_expires__before':
                        (datetime,),
                    't_requested':
                        (datetime,),
                    't_requested__after':
                        (datetime,),
                    't_requested__before':
                        (datetime,),
                    't_satisfied':
                        (datetime,),
                    't_satisfied__after':
                        (datetime,),
                    't_satisfied__before':
                        (datetime,),
                    'use_watchdog':
                        (bool,),
                },
                'attribute_map': {
                    'a_device_groups': 'a_device_groups',
                    'a_devices': 'a_devices',
                    'details': 'details',
                    'id': 'id',
                    'owner': 'owner',
                    'page': 'page',
                    'r_device_group_labels': 'r_device_group_labels',
                    'r_device_groups': 'r_device_groups',
                    'r_devices': 'r_devices',
                    'search': 'search',
                    't_completed': 't_completed',
                    't_completed__after': 't_completed__after',
                    't_completed__before': 't_completed__before',
                    't_lease_expires': 't_lease_expires',
                    't_lease_expires__after': 't_lease_expires__after',
                    't_lease_expires__before': 't_lease_expires__before',
                    't_requested': 't_requested',
                    't_requested__after': 't_requested__after',
                    't_requested__before': 't_requested__before',
                    't_satisfied': 't_satisfied',
                    't_satisfied__after': 't_satisfied__after',
                    't_satisfied__before': 't_satisfied__before',
                    'use_watchdog': 'use_watchdog',
                },
                'location_map': {
                    'a_device_groups': 'query',
                    'a_devices': 'query',
                    'details': 'query',
                    'id': 'query',
                    'owner': 'query',
                    'page': 'query',
                    'r_device_group_labels': 'query',
                    'r_device_groups': 'query',
                    'r_devices': 'query',
                    'search': 'query',
                    't_completed': 'query',
                    't_completed__after': 'query',
                    't_completed__before': 'query',
                    't_lease_expires': 'query',
                    't_lease_expires__after': 'query',
                    't_lease_expires__before': 'query',
                    't_requested': 'query',
                    't_requested__after': 'query',
                    't_requested__before': 'query',
                    't_satisfied': 'query',
                    't_satisfied__after': 'query',
                    't_satisfied__before': 'query',
                    'use_watchdog': 'query',
                },
                'collection_format_map': {
                    'a_device_groups': 'multi',
                    'a_devices': 'multi',
                    'r_device_group_labels': 'multi',
                    'r_device_groups': 'multi',
                    'r_devices': 'multi',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.reservations_cancel_update_endpoint = _Endpoint(
            settings={
                'response_type': (ReservationSessionSerializerReadOnly,),
                'auth': [
                    'cookieAuth',
                    'tokenAuth'
                ],
                'endpoint_path': '/api/reservations/{id}/cancel/',
                'operation_id': 'reservations_cancel_update',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'id',
                ],
                'required': [
                    'id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'id':
                        (str,),
                },
                'attribute_map': {
                    'id': 'id',
                },
                'location_map': {
                    'id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.reservations_create_endpoint = _Endpoint(
            settings={
                'response_type': (ReservationSessionSerializerReadOnly,),
                'auth': [
                    'cookieAuth',
                    'tokenAuth'
                ],
                'endpoint_path': '/api/reservations/',
                'operation_id': 'reservations_create',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'reservation_request',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'reservation_request':
                        (ReservationRequest,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'reservation_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json',
                    'application/x-www-form-urlencoded',
                    'multipart/form-data'
                ]
            },
            api_client=api_client
        )
        self.reservations_list_endpoint = _Endpoint(
            settings={
                'response_type': (PaginatedReservationSessionSerializerReadOnlyList,),
                'auth': [
                    'cookieAuth',
                    'tokenAuth'
                ],
                'endpoint_path': '/api/reservations/',
                'operation_id': 'reservations_list',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'a_device_groups',
                    'a_devices',
                    'details',
                    'id',
                    'owner',
                    'page',
                    'r_device_group_labels',
                    'r_device_groups',
                    'r_devices',
                    'search',
                    't_completed',
                    't_completed__after',
                    't_completed__before',
                    't_lease_expires',
                    't_lease_expires__after',
                    't_lease_expires__before',
                    't_requested',
                    't_requested__after',
                    't_requested__before',
                    't_satisfied',
                    't_satisfied__after',
                    't_satisfied__before',
                    'use_watchdog',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'a_device_groups':
                        ([int],),
                    'a_devices':
                        ([int],),
                    'details':
                        (str,),
                    'id':
                        (str,),
                    'owner':
                        (int,),
                    'page':
                        (int,),
                    'r_device_group_labels':
                        ([int],),
                    'r_device_groups':
                        ([int],),
                    'r_devices':
                        ([int],),
                    'search':
                        (str,),
                    't_completed':
                        (datetime,),
                    't_completed__after':
                        (datetime,),
                    't_completed__before':
                        (datetime,),
                    't_lease_expires':
                        (datetime,),
                    't_lease_expires__after':
                        (datetime,),
                    't_lease_expires__before':
                        (datetime,),
                    't_requested':
                        (datetime,),
                    't_requested__after':
                        (datetime,),
                    't_requested__before':
                        (datetime,),
                    't_satisfied':
                        (datetime,),
                    't_satisfied__after':
                        (datetime,),
                    't_satisfied__before':
                        (datetime,),
                    'use_watchdog':
                        (bool,),
                },
                'attribute_map': {
                    'a_device_groups': 'a_device_groups',
                    'a_devices': 'a_devices',
                    'details': 'details',
                    'id': 'id',
                    'owner': 'owner',
                    'page': 'page',
                    'r_device_group_labels': 'r_device_group_labels',
                    'r_device_groups': 'r_device_groups',
                    'r_devices': 'r_devices',
                    'search': 'search',
                    't_completed': 't_completed',
                    't_completed__after': 't_completed__after',
                    't_completed__before': 't_completed__before',
                    't_lease_expires': 't_lease_expires',
                    't_lease_expires__after': 't_lease_expires__after',
                    't_lease_expires__before': 't_lease_expires__before',
                    't_requested': 't_requested',
                    't_requested__after': 't_requested__after',
                    't_requested__before': 't_requested__before',
                    't_satisfied': 't_satisfied',
                    't_satisfied__after': 't_satisfied__after',
                    't_satisfied__before': 't_satisfied__before',
                    'use_watchdog': 'use_watchdog',
                },
                'location_map': {
                    'a_device_groups': 'query',
                    'a_devices': 'query',
                    'details': 'query',
                    'id': 'query',
                    'owner': 'query',
                    'page': 'query',
                    'r_device_group_labels': 'query',
                    'r_device_groups': 'query',
                    'r_devices': 'query',
                    'search': 'query',
                    't_completed': 'query',
                    't_completed__after': 'query',
                    't_completed__before': 'query',
                    't_lease_expires': 'query',
                    't_lease_expires__after': 'query',
                    't_lease_expires__before': 'query',
                    't_requested': 'query',
                    't_requested__after': 'query',
                    't_requested__before': 'query',
                    't_satisfied': 'query',
                    't_satisfied__after': 'query',
                    't_satisfied__before': 'query',
                    'use_watchdog': 'query',
                },
                'collection_format_map': {
                    'a_device_groups': 'multi',
                    'a_devices': 'multi',
                    'r_device_group_labels': 'multi',
                    'r_device_groups': 'multi',
                    'r_devices': 'multi',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.reservations_release_update_endpoint = _Endpoint(
            settings={
                'response_type': (ReservationSessionSerializerReadOnly,),
                'auth': [
                    'cookieAuth',
                    'tokenAuth'
                ],
                'endpoint_path': '/api/reservations/{id}/release/',
                'operation_id': 'reservations_release_update',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'id',
                ],
                'required': [
                    'id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'id':
                        (str,),
                },
                'attribute_map': {
                    'id': 'id',
                },
                'location_map': {
                    'id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.reservations_retrieve_endpoint = _Endpoint(
            settings={
                'response_type': (ReservationSessionSerializerReadOnly,),
                'auth': [
                    'cookieAuth',
                    'tokenAuth'
                ],
                'endpoint_path': '/api/reservations/{id}/',
                'operation_id': 'reservations_retrieve',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'id',
                ],
                'required': [
                    'id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'id':
                        (str,),
                },
                'attribute_map': {
                    'id': 'id',
                },
                'location_map': {
                    'id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.reservations_update_endpoint = _Endpoint(
            settings={
                'response_type': (ReservationSessionSerializerReadOnly,),
                'auth': [
                    'cookieAuth',
                    'tokenAuth'
                ],
                'endpoint_path': '/api/reservations/{id}/',
                'operation_id': 'reservations_update',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'id',
                ],
                'required': [
                    'id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'id':
                        (str,),
                },
                'attribute_map': {
                    'id': 'id',
                },
                'location_map': {
                    'id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def reservations_active_list(
        self,
        **kwargs
    ):
        """reservations_active_list  # noqa: E501

        Returns all active reservations for the user  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reservations_active_list(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            a_device_groups ([int]): [optional]
            a_devices ([int]): [optional]
            details (str): [optional]
            id (str): [optional]
            owner (int): [optional]
            page (int): A page number within the paginated result set.. [optional]
            r_device_group_labels ([int]): [optional]
            r_device_groups ([int]): [optional]
            r_devices ([int]): [optional]
            search (str): A search term.. [optional]
            t_completed (datetime): [optional]
            t_completed__after (datetime): [optional]
            t_completed__before (datetime): [optional]
            t_lease_expires (datetime): [optional]
            t_lease_expires__after (datetime): [optional]
            t_lease_expires__before (datetime): [optional]
            t_requested (datetime): [optional]
            t_requested__after (datetime): [optional]
            t_requested__before (datetime): [optional]
            t_satisfied (datetime): [optional]
            t_satisfied__after (datetime): [optional]
            t_satisfied__before (datetime): [optional]
            use_watchdog (bool): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            PaginatedReservationSessionSerializerReadOnlyList
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        return self.reservations_active_list_endpoint.call_with_http_info(**kwargs)

    def reservations_cancel_update(
        self,
        id,
        **kwargs
    ):
        """reservations_cancel_update  # noqa: E501

        Release the reservation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reservations_cancel_update(id, async_req=True)
        >>> result = thread.get()

        Args:
            id (str): A UUID string identifying this reservation session.

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            ReservationSessionSerializerReadOnly
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['id'] = \
            id
        return self.reservations_cancel_update_endpoint.call_with_http_info(**kwargs)

    def reservations_create(
        self,
        **kwargs
    ):
        """reservations_create  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reservations_create(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            reservation_request (ReservationRequest): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            ReservationSessionSerializerReadOnly
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        return self.reservations_create_endpoint.call_with_http_info(**kwargs)

    def reservations_list(
        self,
        **kwargs
    ):
        """reservations_list  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reservations_list(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            a_device_groups ([int]): [optional]
            a_devices ([int]): [optional]
            details (str): [optional]
            id (str): [optional]
            owner (int): [optional]
            page (int): A page number within the paginated result set.. [optional]
            r_device_group_labels ([int]): [optional]
            r_device_groups ([int]): [optional]
            r_devices ([int]): [optional]
            search (str): A search term.. [optional]
            t_completed (datetime): [optional]
            t_completed__after (datetime): [optional]
            t_completed__before (datetime): [optional]
            t_lease_expires (datetime): [optional]
            t_lease_expires__after (datetime): [optional]
            t_lease_expires__before (datetime): [optional]
            t_requested (datetime): [optional]
            t_requested__after (datetime): [optional]
            t_requested__before (datetime): [optional]
            t_satisfied (datetime): [optional]
            t_satisfied__after (datetime): [optional]
            t_satisfied__before (datetime): [optional]
            use_watchdog (bool): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            PaginatedReservationSessionSerializerReadOnlyList
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        return self.reservations_list_endpoint.call_with_http_info(**kwargs)

    def reservations_release_update(
        self,
        id,
        **kwargs
    ):
        """reservations_release_update  # noqa: E501

        Release the reservation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reservations_release_update(id, async_req=True)
        >>> result = thread.get()

        Args:
            id (str): A UUID string identifying this reservation session.

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            ReservationSessionSerializerReadOnly
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['id'] = \
            id
        return self.reservations_release_update_endpoint.call_with_http_info(**kwargs)

    def reservations_retrieve(
        self,
        id,
        **kwargs
    ):
        """reservations_retrieve  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reservations_retrieve(id, async_req=True)
        >>> result = thread.get()

        Args:
            id (str): A UUID string identifying this reservation session.

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            ReservationSessionSerializerReadOnly
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['id'] = \
            id
        return self.reservations_retrieve_endpoint.call_with_http_info(**kwargs)

    def reservations_update(
        self,
        id,
        **kwargs
    ):
        """reservations_update  # noqa: E501

        Check queue status or renew lease if reservation is ongoing  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reservations_update(id, async_req=True)
        >>> result = thread.get()

        Args:
            id (str): A UUID string identifying this reservation session.

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            ReservationSessionSerializerReadOnly
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['id'] = \
            id
        return self.reservations_update_endpoint.call_with_http_info(**kwargs)

